 Member
!_ABCDllMode_  EQUATE(0)
!_ABCLinkMode_ EQUATE(1)

 Map
   OLEHost(String StrAddr)
 end

!Includes this class and others
 include('OLETCL.inc')
MaxOleControls equate(5)
!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)
!-------------------------------------------------------------
!--- Hidden window to host OLE Control
!-------------------------------------------------------------
OLEHost Procedure(String StrAddr)
Window WINDOW('OLEHOST'),AT(,,116,99),GRAY
     END
LongAddr    Long,auto
Loc:OLETCl  &OLETCLType
I long,auto
  code
  !create our class reference.
  LongAddr = strAddr
  loc:OleTCl &= (longAddr)

  !open the window
  Open(window)
  If loc:OLETCL.DebugMode then
    display()
  else
    0{prop:hide}='1'
  end

  !Accept loop
  Accept
    Case Event()
    Of Event:OpenWindow
      !create the control(s)
      Loop I=1 to MaxOleControls
        If ~loc:OleTCl.ProgID[I] then break.
        loc:OLETCL.OLEFEQ[I]=Create(0,create:OLE)
        If ~loc:OLETCL.OLEFEQ[I] then
          loc:OLETCL.CreateAbort=True
          Post(Event:CloseWindow)
          cycle
        end
        loc:OLETCL.OLEFEQ[I]{PROP:Create}=loc:OLETCl.ProgID[I]
        loc:OLETCL.OLEobject[I] = loc:OLETCL.OLEFEQ[I]{Prop:Object}     !will have sub(OLETCL.OLEobject[1],1,1)='`' if object made

        !set report exception mode
        If Loc:OLETCL.DebugMode = 2 then         !Carl made Debug=2 show exceptions since any XML report MIA will cause one
          loc:OLETCL.OLEFEQ[I]{prop:ReportException}=1
        else
          loc:OLETCL.OLEFEQ[I]{PROP:ReportException}=0
        end
        unhide(loc:OLETCL.OLEFEQ[I])
      end  !create loop

      !Save FEQ and thread
      Loc:OLETCL.OLEThread = thread()
    End !case event
  end !accept
  close(WINDOW)
  !clear the thread now that the window is closed.
  Clear(Loc:OLETCL.OLETHREAD)
  Return


!-------------------------------------------------------------
!---Start of OLETCL
!-------------------------------------------------------------
OLETCLType.Init            procedure(string pProgID, byte pDebugMode=0,<String pProgid2>,<String pProgID3>,<string pProgID4>, <string progid5>)

DummyWindow WINDOW,AT(,,41,37),timer(1)
     END
StrAddr string(80),auto
  Code
  clear(SELF.CreateAbort)
  clear(SELF.progId[])
  !save debugmode,ProgID
  SELF.ProgID[1]    = pProgID
  SELF.DebugMode = pDebugMode
  If ~omitted(4) then SELF.ProgID[2]=pProgID2.
  If ~omitted(5) then SELF.ProgID[3]=pProgID2.
  If ~omitted(6) then SELF.ProgID[4]=pProgID2.
  If ~omitted(7) then SELF.ProgID[5]=pProgID2.

  !convert class address to a string
  StrAddr=address(SELF)
 
  !start the hidden window with the ole control, wait for the thread to be set.
  clear(SELF.OLEThread)
  Open(DummyWindow)
  0{prop:hide}=1
  Accept
    Case Event()
    of Event:OpenWindow
       Start(OLEHOST,40000,StrAddr)
    Of Event:Timer
      If SELF.OLEThread or SELF.CreateAbort then 0{prop:timer}=0;Post(Event:CloseWindow).
    end
  end !accept
  close(dummywindow)

  !do any needed control initialization here.
  If SELF.CreateAbort then return Return:Fatal.
  Return Return:benign

OLETCLType.Kill              Procedure()
DummyWindow WINDOW,AT(,,41,37),timer(1)
     END
    Code
    !release any objects needing releasing here
    !call any kill/Quit methods now
    If SELF.OLEThread then
      Open(dummywindow)
      0{prop:hide}=1
      accept
        Case Event()
        of Event:OpenWindow
          Post(Event:Closewindow,,SELF.OLEThread)
        Of Event:Timer
          If ~SELF.OLEThread then 0{prop:timer}=0;Post(Event:CloseWindow).
        End !case
      end !accept
      Close(DummyWindow)
    end
    Clear(SELF.OLEFEQ[])
    RETURN
OLETCLType.setprop   procedure(string pcmd, string pProp, long polefeqidx=1) !,byte,proc
res byte(return:benign)
  code
  If SELF.OleThread then
   settarget(,SELF.oleThread)
   SELF.oleFeq[pOleFEQIdx]{clip(pCmd)}=pProp
  else
   res=return:fatal
  end
  Return Return:Benign

OLETCLType.GetObj          Procedure(String pCmd, *cstring cObj, long pOleFEQIdx=1)
cHECKSTR CSTRING(20)
res  byte(0)
  code
  If SELF.OLEThread then
    Settarget(,SELF.OLEThread)
    cObj=SELF.OLEFEQ[pOleFEQIdx]{Clip(pCMD)}
    Settarget()
    If cObj[1]<>'`' then
      CheckStr = Upper(cOBJ)
      res=return:fatal
      if CheckStr = 'NO OLE'
        If SELF.DebugMode then
          Message('No OLE Automation Interface returned for ' & clip(pcmd),'Fatal Error')
        end
        clear(cobj)
      elsif checkstr = 'GETPROPERTYFAILED'
        If SELF.DebugMode then
          Message('Get Property Failed on ' & clip(pcmd),'Fatal Error')
        end
        clear(cObj)
      else
        if SELF.DebugMode then
          message('Get Object Failed on ' & clip(pcmd),'Fatal Error')
          clear(cobj)
        end
      end
    end
  elsif SELF.Debugmode then
    message('Ole Thread Not started - Get Obj Failed')
    clear(cObj)
    res=return:fatal
  end
  Return res

OLETCLType.ReleaseObj      procedure(*cstring cObj, long count=1, long pOleFEQIdx=1)
  code
  If SELF.OLEThread and cobj[1]='`' then
    Settarget(,SELF.OleThread)
    loop count times
      SELF.OLEFEQ[pOLEFEQIDX]{prop:Release}=cObj
    end
    Settarget()
  end
  Clear(cObj)
  return

OLETCLType.Callobj         procedure(*cstring cObj, string pMethod, long pOLEFEQIdx=1) !,string
resultstr string(256)
  code
  If SELF.OLEThread and cObj[1]='`' then
    Settarget(,SELF.OLEThread)
    resultstr = SELF.OLEFEQ[pOLEFEQIDX]{cObj & '.'&clip(pmethod)}
    Settarget()
  end
  Return ResultStr

OLETCLType.getprop      procedure(string pcmd, long polefeqidx=1)!,*?
resultstr string(2000)
checkstr  string(20),auto
  code
  if SELF.OLEThread then
    settarget(,SELF.oleThread)
    Resultstr=SELF.OleFEQ[pOleFEQidx]{clip(pcmd)}
    settarget()
  elsif SELF.debugmode then
    Message('No OLE for Get Prop on '& clip(pcmd),'fatal error')
  end
  
  CheckStr = Upper(resultstr)
  if CheckStr = 'NO OLE'
    If SELF.DebugMode then
        Message('No OLE Automation Interface returned for getprop' & clip(pcmd),'Fatal Error')
    end
    clear(resultstr)
  elsif checkstr = 'GETPROPERTYFAILED'
    If SELF.DebugMode then
      Message('Get Property Failed on ' & clip(pcmd),'Fatal Error')
    end
    clear(resultstr)
  end
  Return ResultStr

OLETCLType.callmethod           procedure(string pcmd, long pOleFEQIdx=1)
  code
  if SELF.OLEThread then
    settarget(,SELF.oleThread)
    SELF.OleFEQ[pOleFEQidx]{clip(pcmd)}
    settarget()
  elsif SELF.debugmode then
    Message('No OLE for call method on '& clip(pcmd),'fatal error')
  end

OLETCLType.setDebugMode   procedure(byte pDebugMode=0)  !Carl made 2 = On ... for some reason
I   long,auto
  code
  SELF.DebugMode = pDebugMode
  if SELF.OLEThread then
      settarget(,SELF.oleThread)
      Loop I=1 to MaxOleControls
        If SELF.OLEFEQ[I]
           !Carl made Debug=2 show exceptions since any XML report MIA will cause one
           SELF.OLEFEQ[I]{prop:ReportException}=choose(SELF.DebugMode = 2,'1','')       !set report exception mode
        end
      End !Loop
      settarget()
   end
   return
